%define versions 1.0-1251 1.0-1512 1.0-1541 1.0-2313 1.0-2314
%{expand:%%define verrel	%(%_sourcedir/nvidia-select_version %versions)}

%define VERSION			%(echo "%verrel"|cut -d- -f1)
%define RELEASE			%(echo "%verrel"|cut -d- -f2)
%define TARNAME			NVIDIA_kernel
%define ver     		%VERSION.%RELEASE
%define rel			alt2

# Define kunamever to build for another kernel
%if %{!?kunamever: 1}0
%define kunamever %(uname -r)
%endif

%define kver		%(echo "%kunamever"| cut -d- -f1)
%define kbuild		%(echo "%kunamever"| cut -d- -f2)
%define kncpu		%(echo "%kunamever"| cut -d- -f3)
%define kpkgprfx	%(if echo "%kver"| grep '2.4.'>/dev/null; then echo "24"; else echo "22"; fi)
%define binPkgName kernel%{kpkgprfx}_%{kncpu}_%{kver}_%{kbuild}-nvidia

Source: ftp://ftp1.detonator.nvidia.com/pub/drivers/english/XFree86_40/%TARNAME-%VERSION-%RELEASE.tar.gz
# A script that tries to build this pkg for all installed kernels
Source1: nvidia-build_for_all_kernels
Source2: nvidia-select_version
NoSource: 0

BuildPreReq: cpp gcc rpm >= 3.0.4
BuildPreReq: kernel%kpkgprfx-headers = %kver-%kbuild
BuildPreReq: kernel%kpkgprfx-%kncpu = %kver-%kbuild

%define myGroup System/Kernel and hardware
%define mySummary NVIDIA kernel module for NVIDIA Architecture support
%define myUrl http://www.nvidia.com
%define myVendor NVIDIA Corp.
%define myLicense NVIDIA
%define mydescription NVIDIA Architecture support for Linux kernel 2.2.X and 2.4.X


Name: kernel-nvidia
Version: ALL
Release: %rel

Group: %myGroup
Summary: %mySummary
Url: %myUrl
Vendor: %myVendor
License: %myLicense
%description
%mydescription


%package -n %binPkgName
Version: %ver
Release: %rel

Provides: %name = %version-%release
Requires: kernel%kpkgprfx-%kncpu = %kver-%kbuild
Requires: rpm >= 3.0.4
Requires: dev >= 3.2

Group: %myGroup
Summary: %mySummary
Url: %myUrl
Vendor: %myVendor
License: %myLicense
%description -n %binPkgName
%mydescription

%prep
%setup -q -n %TARNAME-%VERSION-%RELEASE

%build
%__ln_s /usr/lib/kernel/%kunamever linux
%make NVdriver CC="gcc-2.96 $RPM_OPT_FLAGS" IGNORE_CC_MISMATCH=yes \
    EXTRA_DEFINES=-DMODVERSIONS \
    SYSINCLUDE="/usr/lib/kernel/%kver-%kbuild/include"


%install
    %set_strip_method none
    rm -f /tmp/nvidia-files.lst

    if [ -z "$TOWHAT_KERNEL" ]; then
        export TOWHAT_KERNEL=%kunamever
    fi

    if [ -d $RPM_ROOT/lib/modules/$TOWHAT_KERNEL/kernel ]; then
        INSTALLPATH=/lib/modules/$TOWHAT_KERNEL/kernel/drivers/video
    else
        INSTALLPATH=/lib/modules/$TOWHAT_KERNEL/video
    fi
    mkdir -p $RPM_BUILD_ROOT/$INSTALLPATH
    install -m 0444 NVdriver $RPM_BUILD_ROOT/$INSTALLPATH
    echo "%attr(444 root root) " $INSTALLPATH/NVdriver > /tmp/nvidia-files.lst



%post -n %binPkgName
    /sbin/rmmod NVdriver >/dev/null 2>&1

    confmod="/etc/conf.modules"
    [ -f /etc/modules.conf ] && confmod="/etc/modules.conf"
    conftmp=/tmp/conf$$

    sed '/^alias.*char-major-.*NVdriver/d' < $confmod > $conftmp
    echo "alias char-major-195 NVdriver" >> $conftmp
    mv $conftmp $confmod

    /sbin/depmod -a
    exit 0

%preun -n %binPkgName
if [ $1 = 0 ] ; then
    if [ -n "`/sbin/lsmod | grep NVdriver`" ]; then
        /sbin/rmmod NVdriver \
	    || echo -e "\nWARNING !!!\nUnable to unload module NVIDIA kernel driver.\n" \
	    && echo -e "You must shutdown XFree86 and run command \"/sbin/rmmod NVdriver\"\n"
    fi
fi

%files -n %binPkgName -f /tmp/nvidia-files.lst

%changelog
* Thu Jan 31 2002 Sergey V Turchin <zerg@altlinux.ru> ALL-alt2
- cleanup spec
- fix %%provides %%postun %%files
  thanx Andrey S Pankov <alt-bugs@casper.org.ua>

* Mon Jan 28 2002 Sergey V Turchin <zerg@altlinux.ru> ALL-alt1
- add interactive build

* Wed Dec 25 2001 Ivan Zakharyaschev <imz@altlinux.ru>  1.0.2314-alt2
- include kernel version information in the name of the binary pkg and
  provide a virtual pkg "kernel-nvidia"
- goldhead's "MODVERSIONS" patch obsoleted by make's argument
- allow build for any installed kernel with headers
- set IGNORE_CC_MISMATCH 
  and use gcc-2.96 explicitly not to depend from gcc set by update-alternatives
- own ghost device nodes
- added a script for building the kernel for all installed kernels

* Fri Dec 14 2001 Konstantin Volckov <goldhead@altlinux.ru> 1.0.2314-alt1
- 1.0.2314
- Fixed CFLAGS

* Wed Dec 05 2001 Sergey V Turchin <zerg@altlinux.ru> 1.0.2313-alt1
- new version

* Wed Sep 19 2001 Sergey V Turchin <zerg@altlinux.ru> 1.0.1512-alt8
- fix build with -DMODVERSIONS

* Tue Sep 11 2001 Sergey V Turchin <zerg@altlinux.ru> 1.0.1512-alt7
- first build
# Local variables:
# compile-command: "rpmbuild -ba --target=i586 kernel-nvidia-1.0.2314.my.spec"
# End:
